# Handwritten Digits Recognition

This is a first test of the stm32Cube.AI package and the Keras framework. 
The prupose was to get how all this tools work and how we're suposed to use 
them in order to implement our application of gesture recognition.

For this, we decided to create a handwritten digits recognition model using Keras
since it's a very common problem in deep learning that had already been solved
and many recourses and tutorials are available.
Then we applied that model to cube.AI and generated the necessary library to use
to build the test application.

## Keras model

1.  The first thing is to create the neural network using <b>Keras framework</b>. 
>  Link to the [tutorial](https://machinelearningmastery.com/handwritten-digit-recognition-using-convolutional-neural-networks-python-keras/)

2.  We trained the network using 60000 samples but only 3 itterations.
3.  We tested its accuracy using 10000 new samples and we obtained a 96% accuracy
4.  We saved the model in order to be used in cube.ai

## STM32CUBE.AI
Cube.AI allows us in a first place to validate our model in terms of memory requirements
and accuracy. Then, once it's validated, we can generate the library and the code
upon which we will build our application.

### Validation
The details of the first validation process are shown in the following report:
>  ... <br>model_name         : test_model <br> model_hash         : 8c71faa048d6d32a95813fc1a80802b8 <br> input              : input_0 [784 items, 3.06 KiB, ai_float, FLOAT32, (28, 28, 1)] <br> input (total)      : 3.06 KiB <br> output             : dense_3_nl [10 items, 40 B, ai_float, FLOAT32, (10,)] <br> output (total)     : 40 B <br> params #           : 1,199,882 items (4.58 MiB) <br> macc               : 12,088,182 <br> <b>weights (ro)       : 4,799,528 (4.58 MiB) </b> <br> activations (rw)   : 102,144 (99.75 KiB)  <br> ram (total)        : 105,320 (102.85 KiB) = 102,144 + 3,136 + 40<br>...

We can see that the model can't be used as it is on the NUCLEO-F429ZI because
the size of the weights is 4.58 MiB which exeeds the 2 MiB of flash available.

* **We can add an external memory, or,**
* **Compress the model**

After applying a factor 4 compression we maneged to reduce the size by 73.71% 
without affecting the accuracy. Now the model fits in our board, we can start
to generate the lib.
>  macc=12088182 <b>rom=1.20 MBytes (-73.71%)</b> ram=99.75 KiB io_ram=3.10 KiB

### Application Template
The application template generated by cube.AI is incomplete, we we had to implement
the two functions `void MX_X_CUBE_AI_Process()` and `void MX_X_CUBE_AI_Init()`
in order to run the neural network then build around the user application.

## STM32 Project
For this project we used stm32cubeIDE. The configuration code is generated 
using cubeMX

### PROJECT CONFIGURATION

*  <b>Clock : </b>168 MHz
*  <b>CRC : </b>HSE: Crystal/Ceramic
*  <b>TIM3 : </b><br> 
&nbsp;&nbsp;&nbsp;Prescaler : 16800-1 <br>
&nbsp;&nbsp;&nbsp;Period : 5000-1 <br>
&nbsp;&nbsp;&nbsp;TIM3 Global interrupt : ENABLED
*  <b>USB_OTG_FS : </b><br>
&nbsp;&nbsp;&nbsp;Mode : Device_Only <br>
&nbsp;&nbsp;&nbsp;Activate_SOF : Enabled <br>
&nbsp;&nbsp;&nbsp;Activate_VBUS : Enabled <br>
*  <b>USART3 : </b>
&nbsp;&nbsp;&nbsp;Baude Rate : 921600 <br>
&nbsp;&nbsp;&nbsp;USART3 Global interrupt : ENABLED <br>
*  <b>SYS : </b> Debug : Serial Wire
*   **Heap Size :** 8000

  
### INPUT DATA
In order to feed the NN with new data inputs, we established a serial communication
with the computer using VIRTUAL COM PORT and UART. A python script "write_read_data.py"
is available, here are the steps to follow:
*  Draw a number using a drawing application (like paint in windows) and save it
as a 28x28 px image
*  Specify the path to the image int the `im_path` variable in the script as well
as the COM port on `comPort`
*  Execute the script

The scipt will open the image and process it then send it to the NUCLEO. The 
NUCLEO will run the NN and send back the result which will be printed on the console.

### THE PROGRAM
*  The green led (LD1) is constantly blinking every 1s.
*  The board is listening for available data while the NN is running in an infinite
loop.
*  The blue led (LD2) is turned on whenever an output from the NN is available
*  The red led (LD3) is turned on whenever the number 7 is recognised
*  Initially, the NN is set to recognise an image representing the number 2

